\NeedsTeXFormat{LaTeX2e}
\ProvidesClass{fooClass}[]
\LoadClass{scrreprt}[]
\KOMAoptions{chapterprefix=true}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% OLD %
Changes the chapter mark in the header to "Chapter #:" instead of
"Chapter #"
\renewcommand*{\chaptermarkformat}{%
   \chapapp\nobreakspace\thechapter:\enskip%
}
% Create Chapter Headings separated by a line
\renewcommand{\chapterlineswithprefixformat}[3]{%
   % if the chapter is unnumbered (prefix is empty)
   \ifthenelse{\equal{#2}{}}%
   % then only show the title text
   {#3}%
   % else if chapter is numbered
   {%
      % set numeration in uppercase letters right-aligned
      {\raggedleft \MakeUppercase{#2}}\nobreak
      % create a line spanning the whole page
      \rule[.5\baselineskip]{\textwidth}{0.4pt}\\*
      % insert the title text
      #3
   }%
}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% NEW %
\renewcommand*{\chapterformat}{\MakeUppercase{\chapapp~\thechapter\autodot}}
\renewcommand{\chapterlineswithprefixformat}[3]{%
   % if the chapter is unnumbered (prefix is empty)
   \IfArgIsEmpty{#1}%
   {#3}% then only show the title text
   { % else if chapter is numbered
      % set numeration right-aligned
      {\raggedleft #2\par}\nobreak
      % create a line spanning the whole page
      \raggedchapter\noindent
      \rule[.5\baselineskip]{\textwidth}{0.4pt}\par\nobreak
      % insert the title text
      #3
   }%
}
